#!/usr/bin/perl
#
#  Program:      checkDatastore.cpq
#
#  Copyright:    COPYRIGHT 2001 Compaq Computer Corporation. ALL rights reserved.
#
#  Description:  This program updates an old version of the datastore to the latest version.
#
#
#  History:
#
#
use strict;
use lib qw (
	    /var/cpqcfg/cgi-bin/CompaqConfigurator/system
	    );

use XML::DOM;
use XML::QL;

use config;
use general;
use datastore;
use message;
use error;
use help;

print "* Upgrading datastore\n";

# Begin update
updateNetworkXML();

print "* Upgrade complete!\n";

# Exit
exit(0);


# A sub-routine to update the network.xml datastore file
sub updateNetworkXML {

    my %system = config::system;

    print "-------------\n * Upgrading '.../network.xml'\n";

    my $parser = new XML::DOM::Parser;
    my $doc = $parser->parsefile("$system{'datastore'}/network.xml");


    # Old datastores did not have this field, so we double check for it
    # FIRST Interface
    my $SNMPcheck = eval { $doc->getElementsByTagName("Interface")->item(0)->getElementsByTagName("SNMP")->item(0); } || "";

    if ($SNMPcheck eq "") {

	print " - SNMP tag on FIRST NIC missing; adding it now.\n";
	my $SNMPNode = $doc->createElement("SNMP");
	my $refNode = $doc->getElementsByTagName("Interface")->item(0)->getElementsByTagName("POP3")->item(0);
	$doc->getElementsByTagName("Interface")->item(0)->insertBefore($SNMPNode, $refNode);
      datastore::textNodeUpdate($doc->getElementsByTagName("Interface")->item(0)->getElementsByTagName("SNMP")->item(0), "Yes");
    }
    
    # SECOND Interface
    $SNMPcheck = eval { $doc->getElementsByTagName("Interface")->item(1)->getElementsByTagName("SNMP")->item(0); } || "";
    
    # Old datastores did not have this field, so we double check for it
    if ($SNMPcheck eq "") {

	print " - SNMP tag on SECOND NIC missing; adding it now.\n";

	my $SNMPNode = $doc->createElement("SNMP");
	my $refNode = $doc->getElementsByTagName("Interface")->item(1)->getElementsByTagName("POP3")->item(0);
	$doc->getElementsByTagName("Interface")->item(1)->insertBefore($SNMPNode, $refNode);
      datastore::textNodeUpdate($doc->getElementsByTagName("Interface")->item(1)->getElementsByTagName("SNMP")->item(0), "Yes");
    }

    # Write the XML to file
    $doc->printToFile("$system{'datastore'}/network.xml");

    print " * '.../network.xml' has been upgraded\n-------------\n";

}

