package config;
#
#  Package:      config.pm
#
#  Description:  A package that contains system-wide configuration
#   information.
#
#  History:
#
use strict;

sub system {

    my %system = "";

    $system{'root'} = "/var/cpqcfg/cgi-bin/CompaqConfigurator";
    $system{'vhostroot'} = "/home/VirtualSites";
    $system{'cfgroot'} = "/CompaqConfigurator";
    $system{'docroot'} = "";
    $system{'resource'} = "/var/cpqcfg/cgi-bin/CompaqConfigurator/system/resource";    
    
    $system{'httpd.conf'} = "/etc/httpd/conf/httpd.conf";
    $system{'vhostsfile'} = "/etc/httpd/conf/vhosts.conf";
    $system{'sysconfig'} = "/etc/sysconfig";
    $system{'netscripts'} = "/etc/sysconfig/network-scripts";
    $system{'datastore'} = "/var/cpqcfg/cgi-bin/CompaqConfigurator/system/datastore";
    $system{'backups'} = "/home/backups";
    $system{'version'} = "1.01";
    $system{'release'} = "20";

    # Set the number of items to display on the screen at once
    $system{'displaylimit'} = 25;

    # Timeout values in seconds
    $system{'locktimeout'} = 60;
    $system{'ntptimeout'} = 7;

    # Size of the chunks read in for the backup
    $system{'backupbuffersize'} = 1024;
    $system{'restorebuffersize'} = 1024;

    return (%system);
}


1;
